using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_permission_dependent")]
    public class SecurityPermissionDependentEntity : EntityBase<SecurityPermissionDependentEntityKey>
    {

    public SecurityPermissionDependentEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Column("permission_name")]
    public string PermissionName  { get; set; }
    [Column("dependent")]
    public string Dependent  { get; set; }
    [Column("dependent_detail_name")]
    public string DependentDetailName  { get; set; }
    [Column("dependent_detail_description")]
    public string? DependentDetailDescription  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string PERMISSION_NAME = "PermissionName";
    public const string DEPENDENT = "Dependent";
    public const string DEPENDENT_DETAIL_NAME = "DependentDetailName";
    public const string DEPENDENT_DETAIL_DESCRIPTION = "DependentDetailDescription";

    public const string DB_NAME_SECURITY_PERMISSION_DEPENDENT = "security_permission_dependent";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,permission_name,dependent,dependent_detail_name,dependent_detail_description";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_PERMISSION_NAME = "permission_name";
    public const string DB_DEPENDENT = "dependent";
    public const string DB_DEPENDENT_DETAIL_NAME = "dependent_detail_name";
    public const string DB_DEPENDENT_DETAIL_DESCRIPTION = "dependent_detail_description";


    public static SecurityPermissionDependentEntity GetInstance()
    {
        return new SecurityPermissionDependentEntity();
    }

    public virtual void CopyFrom(SecurityPermissionDependentEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityPermissionDependentEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.PermissionName =  source.PermissionName;
        this.Dependent =  source.Dependent;
        this.DependentDetailName =  source.DependentDetailName;
        this.DependentDetailDescription =  source.DependentDetailDescription;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_PERMISSION_DEPENDENT}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_PERMISSION_DEPENDENT}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_PERMISSION_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_PERMISSION_DEPENDENT}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityPermissionDependentEntity Clone()
    {
        SecurityPermissionDependentEntity result = new SecurityPermissionDependentEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
